require 'win32ole'
# Create GetDiagnosis with all diagnoses

# TODO:
# Fix Excel import so swedish characters are preserved properly

# Open Excel sheet ICD10SE (2016)
excel = WIN32OLE::new("excel.Application")
#workbook = excel.Workbooks.Open("C:\\work\\mock\\script\\GD_ICD10SE_2016.xls")
workbook = excel.Workbooks.Open("C:\\work\\testdata\\mockar\\skript\\GD_ICD10SE_2016.xls")

worksheet = workbook.WorkSheets(1) # Get first sheet.


output_file = File.new("1000_GetDiagnosis.xml", "w")
output_file.puts('<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:urn="urn:riv:clinicalprocess:healthcond:description:GetDiagnosisResponder:2" xmlns:urn1="urn:riv:clinicalprocess:healthcond:description:2"
xmlns:urn2="urn:riv:clinicalprocess:healthcond:description:2.1">')
# This is how the response starts. Note single quotes for the full string, since double quotes are used inside.

output_file.puts('   <soapenv:Header/>
   <soapenv:Body>
      <urn:GetDiagnosisResponse>')
# Empty Header since I don't want to simulate aggregating service.
	  
$i = 1

while $i < 1001 do
# Create X posts.
$date = "201#{$i%6}0#{1 + rand(9)}0#{1 + rand(9)}000000"
# Variety in date field.

tmpa = "a#{$i}"
tmpb = "b#{$i}"
diagnoskod = worksheet.Range(tmpa).Value # Get diagnosis code for cell A$i in Excel sheet.
diagnostext = worksheet.Range(tmpb).Value # Get diagnosis tesxt for cell B$i in Excel sheet.

output_file.puts("         <urn:diagnosis><urn1:diagnosisHeader>
               <urn1:documentId>JOL-MOCK-GD-04-#{$i}</urn1:documentId>
               <urn1:sourceSystemHSAId>JOL-MOCK</urn1:sourceSystemHSAId>
               <urn1:documentTime>#{$date}</urn1:documentTime>
               <urn1:patientId>
                  <urn1:id>189908029805</urn1:id>
                  <urn1:type>1.2.752.129.2.1.3.1</urn1:type>
               </urn1:patientId>
               <urn1:accountableHealthcareProfessional>
                  <urn1:authorTime>#{$date}</urn1:authorTime>
                  <urn1:healthcareProfessionalOrgUnit>
                     <urn1:orgUnitHSAId>healthcareProfessionalOrgUnit</urn1:orgUnitHSAId>
                     <urn1:orgUnitName>orgUnitName</urn1:orgUnitName>
                  </urn1:healthcareProfessionalOrgUnit>
				  <urn1:healthcareProfessionalCareUnitHSAId>TSTNMT2321000156-1003</urn1:healthcareProfessionalCareUnitHSAId>
                  <urn1:healthcareProfessionalCareGiverHSAId>TSTNMT2321000156-1002</urn1:healthcareProfessionalCareGiverHSAId>
               </urn1:accountableHealthcareProfessional>
               <urn1:approvedForPatient>true</urn1:approvedForPatient>
            </urn1:diagnosisHeader>
            <urn1:diagnosisBody>
               <urn1:typeOfDiagnosis>Huvuddiagnos</urn1:typeOfDiagnosis>
				  <urn1:diagnosisTime>20151201080000</urn1:diagnosisTime>
				  <urn1:chronicDiagnosis>true</urn1:chronicDiagnosis>
                <urn1:diagnosisTime>20151201080000</urn1:diagnosisTime>
                <urn1:diagnosisCode>
                    <urn1:code>#{diagnoskod}</urn1:code>
                    <urn1:codeSystem>1.2.752.116.1.1.1.1.3</urn1:codeSystem>
                    <urn1:displayName>#{diagnostext}, post #{$i}</urn1:displayName>
                </urn1:diagnosisCode>
            </urn1:diagnosisBody>
        </urn:diagnosis>")				
		$i=$i+1
end
# Adds numbering for documentId och diagnosis text
	
output_file.puts('         <urn2:result>
            <urn2:resultCode>OK</urn2:resultCode>
            <urn2:logId>1</urn2:logId>
         </urn2:result>')
# Resultat was OK
output_file.puts('      </urn:GetDiagnosisResponse>
   </soapenv:Body>
</soapenv:Envelope>')
# Ending response

output_file.close
